com.io7m.jpra.compiler.core.checker

## Interface JPRACheckerType

- All Known Implementing Classes:
    JPRAChecker

      public interface JPRACheckerType

  The type of type checkers.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `StatementCommandType<IdentifierType,TType>` | `checkCommandType(StatementCommandType<IdentifierType,Untyped> s)` Check a `:type` command.
    `void` | `checkPackageBegin(StatementPackageBegin<IdentifierType,Untyped> s)` Check a package begin statement.
    `PackageContextType` | `checkPackageEnd(StatementPackageEnd<IdentifierType,Untyped> s)` Complete the current package.
    `TypeDeclType<IdentifierType,TType>` | `checkTypeDeclaration(TypeDeclType<IdentifierType,Untyped> decl)` Check a type declaration.
    `TypeExprType<IdentifierType,TType>` | `checkTypeExpression(TypeExprType<IdentifierType,Untyped> expr)` Check a type expression.

- - ### Method Detail

    - #### checkPackageBegin

          void checkPackageBegin(StatementPackageBegin<IdentifierType,Untyped> s)
                          throws JPRACompilerCheckerException

      Check a package begin statement.
      Parameters:
        `s` - The statement
      Throws:
        `JPRACompilerCheckerException` - On resolution errors

    - #### checkPackageEnd

          PackageContextType checkPackageEnd(StatementPackageEnd<IdentifierType,Untyped> s)
                                      throws JPRACompilerCheckerException

      Complete the current package.
      Parameters:
        `s` - The statement
      Returns:
        A completed package context
      Throws:
        `JPRACompilerCheckerException` - On resolution errors

    - #### checkTypeDeclaration

          TypeDeclType<IdentifierType,TType> checkTypeDeclaration(TypeDeclType<IdentifierType,Untyped> decl)
                                                           throws JPRACompilerCheckerException

      Check a type declaration.
      Parameters:
        `decl` - The input declaration
      Returns:
        A type declaration
      Throws:
        `JPRACompilerCheckerException` - On type errors

    - #### checkTypeExpression

          TypeExprType<IdentifierType,TType> checkTypeExpression(TypeExprType<IdentifierType,Untyped> expr)
                                                          throws JPRACompilerCheckerException

      Check a type expression.
      Parameters:
        `expr` - The input expression
      Returns:
        A type expression
      Throws:
        `JPRACompilerCheckerException` - On type errors

    - #### checkCommandType

          StatementCommandType<IdentifierType,TType> checkCommandType(StatementCommandType<IdentifierType,Untyped> s)
                                                               throws JPRACompilerCheckerException

      Check a `:type` command.
      Parameters:
        `s` - The statement
      Returns:
        A type expression
      Throws:
        `JPRACompilerCheckerException` - On type errors

Copyright © 2016 <code@io7m.com> http://io7m.com